char rcsid_bf_task[] = "$Id: bf_task.c,v 1.3 1992/08/10 17:31:39 pjames Exp $";

#include "functions.h"
#include "list.h"
#include "storage.h"
#include "tasks.h"
#include "utils.h"

static package
bf_task_id(Var arglist, Byte next, void *vdata, Objid progr) 
{ /* () */
    Var r;
    r.type = TYPE_NUM;
    r.v.num = task_id();
    free_var(arglist);
    return make_var_pack(r);
}

static package
bf_queued_tasks(Var arglist, Byte next, void *vdata, Objid progr)
{
    Var r;
    r = queued_tasks(progr);
    free_var(arglist);
    return make_var_pack(r);
}

static package
bf_kill_task(Var arglist, Byte next, void *vdata, Objid progr)
{
    enum error	e = kill_task(arglist.v.list[1].v.num, progr);
    free_var(arglist);
    
    if (e != E_NONE)
	return make_error_pack(e);
    
    return no_var_pack();
}

static package
bf_output_delimiters(Var arglist, Byte next, void *vdata, Objid progr)
{
    Var r;
    Objid oid = arglist.v.list[1].v.obj;
    
    free_var(arglist);
    
    if (!is_wizard(progr) && progr != oid) 
	return make_error_pack(E_PERM);
    else {
	const char *prefix, *suffix;
	
	if (!output_delimiters(oid, &prefix, &suffix)) 
	    return make_error_pack(E_INVARG);
	else {
	    r = new_list(2);
	    r.v.list[1].type = r.v.list[2].type = TYPE_STR;
	    r.v.list[1].v.str = strdup(prefix);
	    r.v.list[2].v.str = strdup(suffix);
	}
    }
    return make_var_pack(r);
}

void
register_bf_task(void)
{ 
    (void) register_function("task_id", 0, 0, bf_task_id);
    (void) register_function("queued_tasks", 0, 0, bf_queued_tasks);
    (void) register_function("kill_task", 1, 1, bf_kill_task, TYPE_NUM);
    (void) register_function("output_delimiters", 1, 1, bf_output_delimiters,
			     TYPE_OBJ);
}

/* $Log: bf_task.c,v $
 * Revision 1.3  1992/08/10  17:31:39  pjames
 * Updated #includes.  Used new registration method.  Built in function
 * receives only programmer, not whole Parse_Info.  Moved set_task_perms,
 * caller_perms, and callers to execute.c
 *
 * Revision 1.2  1992/07/20  23:54:41  pavel
 * Added rcsid_<filename-root> declaration to hold the RCS ident. string.
 *
 * Revision 1.1  1992/07/20  23:23:12  pavel
 * Initial RCS-controlled version.
 * */
