char rcsid_rt_env[] = "$Id: eval_env.c,v 1.1 1992/08/10 16:20:00 pjames Exp $";

#include "eval_env.h"
#include "storage.h"
#include "sym_table.h"
#include "utils.h"

Var *
new_rt_env(unsigned size)
{
    Var *ret = mymalloc(size * sizeof(Var), M_RT_ENV);
    unsigned i;
    
    for (i = 0; i < size; i++)
	ret[i].type = TYPE_ANY;

    return ret;
}    

void 
free_rt_env(Var *rt_env, unsigned size)
{
    register unsigned i;

    for (i = 0; i < size; i++)
	free_var(rt_env[i]);
    myfree((void *) rt_env, M_RT_ENV);
}

Var *
copy_rt_env(Var *from, unsigned size)
{
    unsigned i;

    Var *ret = new_rt_env(size);
    for (i = 0; i < size; i++) 
	ret[i] = vardup(from[i]);
    return ret;
}

void
fill_in_rt_consts(Var *env)
{
    Var v;

    v.type = TYPE_NUM;
    v.v.num = (int) TYPE_ERR;     env[SLOT_ERR] = vardup(v);
    v.v.num = (int) TYPE_NUM;     env[SLOT_NUM] = vardup(v);
    v.v.num = (int) TYPE_STR;     env[SLOT_STR] = vardup(v);
    v.v.num = (int) TYPE_OBJ;     env[SLOT_OBJ] = vardup(v);
    v.v.num = (int) TYPE_LIST;    env[SLOT_LIST] = vardup(v);
}

void
set_rt_env_obj(Var *env, int slot, Objid o)
{
    Var v;
    v.type = TYPE_OBJ;
    v.v.obj = o;
    env[slot] = vardup(v);
}

void
set_rt_env_str(Var *env, int slot, char *s)
{
    Var v;
    v.type = TYPE_STR;
    v.v.str = s;
    env[slot] = v;
}

void
set_rt_env_var(Var *env, int slot, Var v)
{
    env[slot] = v;
}

/* $Log: eval_env.c,v $
 * Revision 1.1  1992/08/10  16:20:00  pjames
 * Initial RCS-controlled version
 *
   */
