char rcsid_program[] = "$Id: program.c,v 1.4 1992/08/10 16:54:22 pjames Exp $";

#include "structures.h"
#include "ast.h"
#include "storage.h"

Program *
new_program(void)
{
  Program    *p = (Program *) mymalloc(sizeof(Program), M_PROGRAM);
  p->ref_count = 1;
  p->first_lineno = 1;
  return p;
}

void
free_program(Program *p)
{
  unsigned i;
  p->ref_count--;

  if (p->ref_count == 0) {

    for (i = 0; i < p->num_literals; i++)
      if (p->literals[i].type == TYPE_STR)  /* will not be a LIST */
	ak_dealloc_string(p->literals[i].v.str);    
    if (p->literals)
      myfree((void *) p->literals, M_LIT_LIST);  /* free backbone */
   
    for (i = 0; i < p->fork_vectors_size; i++)
      FREE_BYTECODES(p->fork_vectors[i]);
    if (p->fork_vectors_size)
      myfree((void *) p->fork_vectors, M_FORK_VECTORS);
    
    for (i = 0; i < p->num_var_names; i++)
      ak_dealloc_string(p->var_names[i]);      /* free strings -- idnames */
    myfree((void *) p->var_names, M_NAMES);

    FREE_BYTECODES(p->main_vector);
    
    /* freeing the storage for Program itself */
    myfree((void *) p, M_PROGRAM);
  }
}

/* $Log: program.c,v $
 * Revision 1.4  1992/08/10  16:54:22  pjames
 * Updated #includes.
 *
 * Revision 1.3  1992/07/27  18:16:27  pjames
 * Changed name of ct_env to var_names, const_env to literals, and
 * f_vectors to fork_vectors.
 *
 * Revision 1.2  1992/07/21  00:05:45  pavel
 * Added rcsid_<filename-root> declaration to hold the RCS ident. string.
 *
 * Revision 1.1  1992/07/20  23:23:12  pavel
 * Initial RCS-controlled version.
 * */
